import 'package:flutter/material.dart';
import 'package:image_picker/image_picker.dart';
import 'package:navigine_api/navigine_api.dart';
import 'package:navigine_api_example/screens/sublocation_detail.dart';
import '../widgets/sub_location_image.dart';

class LocationDetail extends StatefulWidget {
  final Location location;
  LocationDetail({this.location});

  @override
  _LocationDetailState createState() => _LocationDetailState();
}

class _LocationDetailState extends State<LocationDetail> {
  Location l;

  initState() {
    super.initState();
    l = widget.location;
    initAsync();
  }

  initAsync() async {
    NavigineAPI n = NavigineAPI.initilize(userHash: "3F77-4634-FCEE-2423");
    Location _l = await n.getLocation(l.id);
    setState(() {
      l = _l;
    });
  }

  addNewSubLocation() async {
    var image = await ImagePicker.pickImage(source: ImageSource.gallery);
    l.addNewSubLocation(
      "newnewsubbb1",
      image,
      fileHeight: 122,
      fileWidth: 123,
      hor: 1,
      lat: 12.12,
      lon: 15.12,
      timeZone: 5,
    );
    initAsync();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(l.title),
      ),
      floatingActionButton: FloatingActionButton.extended(
        label: Text("Add Sub Location"),
        icon: Icon(Icons.add),
        onPressed: addNewSubLocation,
      ),
      body: ListView.builder(
        itemBuilder: (context, index) {
          SubLocation sl = l.subLocations[index];
          return ListTile(
            title: Text(sl.title),
            onTap: () async {
              await sl.getImageURL();
              await sl.getAllBeacons();
              Navigator.push(
                  context,
                  MaterialPageRoute(
                      builder: (_) => SubLocationDetail(subLocation: sl)));
            },
          );
        },
        itemCount: l.subLocations.length,
      ),
    );
  }
}
