import 'package:flutter/material.dart';
import 'package:image_picker/image_picker.dart';
import 'package:navigine_api/navigine_api.dart';
import './location_detail.dart';

class LocationsScreen extends StatefulWidget {
  @override
  _LocationsScreenState createState() => _LocationsScreenState();
}

class _LocationsScreenState extends State<LocationsScreen> {
  List<Location> locations = [];
  NavigineAPI n = NavigineAPI.initilize(userHash: "3F77-4634-FCEE-2423");

  @override
  void initState() {
    super.initState();
    initAsync();
  }

  initAsync() async {
    List<Location> locations = await n.getAllLocations();

    setState(() {
      this.locations = locations;
    });
  }

  addLocation() async {
    Location l = await n.createNewLocation("sdsd");
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Navigine API Example'),
      ),
      floatingActionButton: FloatingActionButton.extended(
        label: Text("Add Location"),
        icon: Icon(Icons.add),
        onPressed: addLocation,
      ),
      body: ListView.builder(
        itemBuilder: (context, index) {
          Location l = locations[index];
          return ListTile(
            onTap: () {
              Navigator.push(
                  context,
                  MaterialPageRoute(
                      builder: (context) => LocationDetail(location: l)));
            },
            title: Text(l.title ?? ""),
          );
        },
        itemCount: locations.length,
      ),
    );
  }
}
